Loading...
Searching...
No Matches
juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

## Detailed Description

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
class juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >

Holds a list of objects derived from ReferenceCountedObject, or which implement basic reference-count handling methods.

The template parameter specifies the class of the object you want to point to - the easiest way to make a class reference-countable is to simply make it inherit from ReferenceCountedObject or SingleThreadedReferenceCountedObject, but if you need to, you can roll your own reference-countable class by implementing a set of methods called incReferenceCount(), decReferenceCount(), and decReferenceCountWithoutDeleting(). See ReferenceCountedObject for examples of how these methods should behave.

A ReferenceCountedArray holds objects derived from ReferenceCountedObject, and takes care of incrementing and decrementing their ref counts when they are added and removed from the array.

To make all the array's methods thread-safe, pass in "CriticalSection" as the templated TypeOfCriticalSectionToUse parameter, instead of the default DummyCriticalSection.

See also
  Array, OwnedArray, StringArray

The documentation for this class was generated from the following file:

- juce_core/containers/juce_ReferenceCountedArray.h

## Public Types

using | ObjectClassPtr = ReferenceCountedObjectPtr<ObjectClass>
using | ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType
| Returns the type of scoped lock to use for locking this array.

## Public Member Functions

| ReferenceCountedArray ()=default
| Creates an empty array.
| ReferenceCountedArray (const ReferenceCountedArray &other) noexcept
| Creates a copy of another array.
| ReferenceCountedArray (ReferenceCountedArray &&other) noexcept
| Moves from another array.
template<class OtherObjectClass, class OtherCriticalSection>
| ReferenceCountedArray (const ReferenceCountedArray< OtherObjectClass, OtherCriticalSection > &other) noexcept
| Creates a copy of another array.
ReferenceCountedArray & | operator= (const ReferenceCountedArray &other) noexcept
| Copies another array into this one.
template<class OtherObjectClass>
ReferenceCountedArray & | operator= (const ReferenceCountedArray< OtherObjectClass, TypeOfCriticalSectionToUse > &other) noexcept
| Copies another array into this one.
ReferenceCountedArray & | operator= (ReferenceCountedArray &&other) noexcept
| Moves from another array.
| ~ReferenceCountedArray ()
| Destructor.
void | clear ()
| Removes all objects from the array.
void | clearQuick ()
| Removes all objects from the array without freeing the array's allocated storage.
int | size () const noexcept
| Returns the current number of objects in the array.
bool | isEmpty () const noexcept
| Returns true if the array is empty, false otherwise.
ObjectClassPtr | operator[] (int index) const noexcept
| Returns a pointer to the object at this index in the array.
ObjectClassPtr | getUnchecked (int index) const noexcept
| Returns a pointer to the object at this index in the array, without checking whether the index is in-range.
ObjectClass * | getObjectPointer (int index) const noexcept
| Returns a raw pointer to the object at this index in the array.
ObjectClass * | getObjectPointerUnchecked (int index) const noexcept
| Returns a raw pointer to the object at this index in the array, without checking whether the index is in-range.
ObjectClassPtr | getFirst () const noexcept
| Returns a pointer to the first object in the array.
ObjectClassPtr | getLast () const noexcept
| Returns a pointer to the last object in the array.
ObjectClass ** | getRawDataPointer () const noexcept
| Returns a pointer to the actual array data.
ObjectClass ** | begin () noexcept
| Returns a pointer to the first element in the array.
ObjectClass *const * | begin () const noexcept
| Returns a pointer to the first element in the array.
ObjectClass ** | end () noexcept
| Returns a pointer to the element which follows the last element in the array.
ObjectClass *const * | end () const noexcept
| Returns a pointer to the element which follows the last element in the array.
ObjectClass ** | data () noexcept
| Returns a pointer to the first element in the array.
ObjectClass *const * | data () const noexcept
| Returns a pointer to the first element in the array.
int | indexOf (const ObjectClass *objectToLookFor) const noexcept
| Finds the index of the first occurrence of an object in the array.
int | indexOf (const ObjectClassPtr &objectToLookFor) const noexcept
| Finds the index of the first occurrence of an object in the array.
bool | contains (const ObjectClass *objectToLookFor) const noexcept
| Returns true if the array contains a specified object.
bool | contains (const ObjectClassPtr &objectToLookFor) const noexcept
| Returns true if the array contains a specified object.
ObjectClass * | add (ObjectClass *newObject)
| Appends a new object to the end of the array.
ObjectClass * | add (const ObjectClassPtr &newObject)
| Appends a new object to the end of the array.
ObjectClass * | insert (int indexToInsertAt, ObjectClass *newObject)
| Inserts a new object into the array at the given index.
ObjectClass * | insert (int indexToInsertAt, const ObjectClassPtr &newObject)
| Inserts a new object into the array at the given index.
bool | addIfNotAlreadyThere (ObjectClass *newObject)
| Appends a new object at the end of the array as long as the array doesn't already contain it.
bool | addIfNotAlreadyThere (const ObjectClassPtr &newObject)
| Appends a new object at the end of the array as long as the array doesn't already contain it.
void | set (int indexToChange, ObjectClass *newObject)
| Replaces an object in the array with a different one.
void | set (int indexToChange, const ObjectClassPtr &newObject)
| Replaces an object in the array with a different one.
void | addArray (const ReferenceCountedArray &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1) noexcept
| Adds elements from another array to the end of this array.
template<class ElementComparator>
int | addSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
| Inserts a new object into the array assuming that the array is sorted.
template<class ElementComparator>
void | addOrReplaceSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
| Inserts or replaces an object in the array, assuming it is sorted.
template<class ElementComparator>
int | indexOfSorted (ElementComparator &comparator, const ObjectClass *objectToLookFor) const noexcept
| Finds the index of an object in the array, assuming that the array is sorted.
void | remove (int indexToRemove)
| Removes an object from the array.
ObjectClassPtr | removeAndReturn (int indexToRemove)
| Removes and returns an object from the array.
void | removeObject (ObjectClass *objectToRemove)
| Removes the first occurrence of a specified object from the array.
void | removeObject (const ObjectClassPtr &objectToRemove)
| Removes the first occurrence of a specified object from the array.
void | removeRange (int startIndex, int numberToRemove)
| Removes a range of objects from the array.
void | removeLast (int howManyToRemove=1)
| Removes the last n objects from the array.
void | swap (int index1, int index2) noexcept
| Swaps a pair of objects in the array.
void | move (int currentIndex, int newIndex) noexcept
| Moves one of the objects to a different position.
template<class OtherArrayType>
void | swapWith (OtherArrayType &otherArray) noexcept
| This swaps the contents of this array with those of another array.
bool | operator== (const ReferenceCountedArray &other) const noexcept
| Compares this array to another one.
bool | operator!= (const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > &other) const noexcept
| Compares this array to another one.
template<class ElementComparator>
void | sort (ElementComparator &comparator, bool retainOrderOfEquivalentItems=false) noexcept
| Sorts the elements in the array.
void | minimiseStorageOverheads () noexcept
| Reduces the amount of storage being used by the array.
void | ensureStorageAllocated (const int minNumElements)
| Increases the array's internal storage to hold a minimum number of elements.
const TypeOfCriticalSectionToUse & | getLock () const noexcept
| Returns the CriticalSection that locks this array.

## Member Typedef Documentation

## ObjectClassPtr

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

using juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ObjectClassPtr = ReferenceCountedObjectPtr<ObjectClass>

## ScopedLockType

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

using juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

Returns the type of scoped lock to use for locking this array.

## Constructors and Destructors

## ReferenceCountedArray() [1/4]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( |  | ) |

default

Creates an empty array.

See also
  ReferenceCountedObject, Array, OwnedArray

Referenced by addArray(), operator!=(), operator=(), operator=(), operator=(), operator==(), ReferenceCountedArray(), ReferenceCountedArray(), and ReferenceCountedArray().

## ReferenceCountedArray() [2/4]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) |

inline noexcept

Creates a copy of another array.

References ReferenceCountedArray().

## ReferenceCountedArray() [3/4]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |

inline noexcept

Moves from another array.

References ReferenceCountedArray().

## ReferenceCountedArray() [4/4]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass, class OtherCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | const ReferenceCountedArray< OtherObjectClass, OtherCriticalSection > & | other | ) |

inline noexcept

Creates a copy of another array.

References ReferenceCountedArray().

## ~ReferenceCountedArray()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::~ReferenceCountedArray | ( |  | ) |

inline

Destructor.

Any objects in the array will be released, and may be deleted if not referenced from elsewhere.

## Member Functions

## operator=() [1/3]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) |

inline noexcept

Copies another array into this one.

Any existing objects in this array will first be released.

References ReferenceCountedArray(), and swapWith().

## operator=() [2/3]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass>

ReferenceCountedArray & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | const ReferenceCountedArray< OtherObjectClass, TypeOfCriticalSectionToUse > & | other | ) |

inline noexcept

Copies another array into this one.

Any existing objects in this array will first be released.

References ReferenceCountedArray(), and swapWith().

## operator=() [3/3]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |

inline noexcept

Moves from another array.

References ReferenceCountedArray().

## clear()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear | ( |  | ) |

inline

Removes all objects from the array.

Any objects in the array whose reference counts drop to zero will be deleted.

References clearQuick(), and getLock().

## clearQuick()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick | ( |  | ) |

inline

Removes all objects from the array without freeing the array's allocated storage.

Any objects in the array that whose reference counts drop to zero will be deleted.

See also
  clear

References getLock().

Referenced by clear().

## size()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::size | ( |  | ) | const

inline noexcept

Returns the current number of objects in the array.

Referenced by isEmpty().

## isEmpty()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty | ( |  | ) | const

inline noexcept

Returns true if the array is empty, false otherwise.

References size().

## operator[]()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[] | ( | int | index | ) | const

inline noexcept

Returns a pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

References getObjectPointer().

## getUnchecked()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked | ( | int | index | ) | const

inline noexcept

Returns a pointer to the object at this index in the array, without checking whether the index is in-range.

This is a faster and less safe version of operator[] which doesn't check the index passed in, so it can be used when you're sure the index is always going to be legal.

References getObjectPointerUnchecked().

## getObjectPointer()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointer | ( | int | index | ) | const

inline noexcept

Returns a raw pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

References getLock().

Referenced by operator[]().

## getObjectPointerUnchecked()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointerUnchecked | ( | int | index | ) | const

inline noexcept

Returns a raw pointer to the object at this index in the array, without checking whether the index is in-range.

References getLock().

Referenced by getUnchecked().

## getFirst()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst | ( |  | ) | const

inline noexcept

Returns a pointer to the first object in the array.

This will return a null pointer if the array's empty.

See also
  getLast

References getLock().

## getLast()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast | ( |  | ) | const

inline noexcept

Returns a pointer to the last object in the array.

This will return a null pointer if the array's empty.

See also
  getFirst

References getLock().

## getRawDataPointer()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getRawDataPointer | ( |  | ) | const

inline noexcept

Returns a pointer to the actual array data.

This pointer will only be valid until the next time a non-const method is called on the array.

## begin() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) |

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

Referenced by data(), and data().

## begin() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) | const

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## end() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) |

inline noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## end() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) | const

inline noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## data() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) |

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

References begin().

## data() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) | const

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

References begin().

## indexOf() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClass * | objectToLookFor | ) | const

inline noexcept

Finds the index of the first occurrence of an object in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

References getLock().

Referenced by removeObject().

## indexOf() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClassPtr & | objectToLookFor | ) | const

inline noexcept

Finds the index of the first occurrence of an object in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

References indexOf().

Referenced by indexOf().

## contains() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClass * | objectToLookFor | ) | const

inline noexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

References getLock().

Referenced by addIfNotAlreadyThere().

## contains() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClassPtr & | objectToLookFor | ) | const

inline noexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

References contains().

Referenced by contains().

## add() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | ObjectClass * | newObject | ) |

inline

Appends a new object to the end of the array.

This will increase the new object's reference count.

Parameters

  newObject | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addArray

References getLock().

Referenced by addIfNotAlreadyThere().

## add() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | const ObjectClassPtr & | newObject | ) |

inline

Appends a new object to the end of the array.

This will increase the new object's reference count.

Parameters

  newObject | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addArray

References add(), and juce::ReferenceCountedObjectPtr< ObjectType >::get().

Referenced by add().

## insert() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | ObjectClass * | newObject )

inline

Inserts a new object into the array at the given index.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

This will increase the new object's reference count.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

See also
  add, addSorted, addIfNotAlreadyThere, set

Referenced by addOrReplaceSorted(), and addSorted().

## insert() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | const ObjectClassPtr & | newObject )

inline

Inserts a new object into the array at the given index.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

This will increase the new object's reference count.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

See also
  add, addSorted, addIfNotAlreadyThere, set

References juce::ReferenceCountedObjectPtr< ObjectType >::get(), and insert().

Referenced by insert().

## addIfNotAlreadyThere() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere | ( | ObjectClass * | newObject | ) |

inline

Appends a new object at the end of the array as long as the array doesn't already contain it.

If the array already contains a matching object, nothing will be done.

Parameters

  newObject | the new object to add to the array

Returns
  true if the object has been added, false otherwise

References add(), contains(), and getLock().

## addIfNotAlreadyThere() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere | ( | const ObjectClassPtr & | newObject | ) |

inline

Appends a new object at the end of the array as long as the array doesn't already contain it.

If the array already contains a matching object, nothing will be done.

Parameters

  newObject | the new object to add to the array

Returns
  true if the object has been added, false otherwise

References addIfNotAlreadyThere(), and juce::ReferenceCountedObjectPtr< ObjectType >::get().

Referenced by addIfNotAlreadyThere().

## set() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | ObjectClass * | newObject )

inline

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

The object being added has its reference count increased, and if it's replacing another object, then that one has its reference count decreased, and may be deleted.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.

See also
  add, insert, remove

References getLock().

Referenced by addOrReplaceSorted().

## set() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | const ObjectClassPtr & | newObject )

inline

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

The object being added has its reference count increased, and if it's replacing another object, then that one has its reference count decreased, and may be deleted.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.

See also
  add, insert, remove

References juce::ReferenceCountedObjectPtr< ObjectType >::get(), and set().

Referenced by set().

## addArray()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | arrayToAddFrom,
|  | int | startIndex = 0,
|  | int | numElementsToAdd = -1 )

inline noexcept

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

References getLock(), and ReferenceCountedArray().

## addSorted()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject )

inline noexcept

Inserts a new object into the array assuming that the array is sorted.

This will use a comparator to find the position at which the new object should go. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator object to use to compare the elements - see the sort() method for details about this object's form
  newObject | the new object to insert to the array

Returns
  the index at which the new object was added

See also
  add, sort

References juce::findInsertIndexInSortedArray(), getLock(), and insert().

## addOrReplaceSorted()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addOrReplaceSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject )

inline noexcept

Inserts or replaces an object in the array, assuming it is sorted.

This is similar to addSorted, but if a matching element already exists, then it will be replaced by the new one, rather than the new one being added as well.

References juce::findInsertIndexInSortedArray(), getLock(), insert(), and set().

## indexOfSorted()

template<class ObjectClass, class TypeOfCriticalSectionToUse>
template<class ElementComparator>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted | ( | ElementComparator & | comparator,
|  | const ObjectClass * | objectToLookFor ) const

noexcept

Finds the index of an object in the array, assuming that the array is sorted.

This will use a comparator to do a binary-chop to find the index of the given element, if it exists. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort() method for details about the form this object should take
  objectToLookFor | the object to search for

Returns
  the index of the element, or -1 if it's not found

See also
  addSorted, sort

References getLock().

## remove()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove | ( | int | indexToRemove | ) |

inline

Removes an object from the array.

This will remove the object at a given index and move back all the subsequent objects to close the gap.

If the index passed in is out-of-range, nothing will happen.

The object that is removed will have its reference count decreased, and may be deleted if not referenced from elsewhere.

Parameters

  indexToRemove | the index of the element to remove

See also
  removeObject, removeRange

References getLock(), juce::isPositiveAndBelow(), and minimiseStorageOverheads().

Referenced by removeLast(), and removeObject().

## removeAndReturn()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn | ( | int | indexToRemove | ) |

inline

Removes and returns an object from the array.

This will remove the object at a given index and return it, moving back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen and a null pointer will be returned.

Parameters

  indexToRemove | the index of the element to remove

See also
  remove, removeObject, removeRange

References getLock(), juce::isPositiveAndBelow(), and minimiseStorageOverheads().

## removeObject() [1/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | ObjectClass * | objectToRemove | ) |

inline

Removes the first occurrence of a specified object from the array.

If the item isn't found, no action is taken. If it is found, it is removed and has its reference count decreased.

Parameters

  objectToRemove | the object to try to remove

See also
  remove, removeRange

References getLock(), indexOf(), and remove().

## removeObject() [2/2]

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | const ObjectClassPtr & | objectToRemove | ) |

inline

Removes the first occurrence of a specified object from the array.

If the item isn't found, no action is taken. If it is found, it is removed and has its reference count decreased.

Parameters

  objectToRemove | the object to try to remove

See also
  remove, removeRange

References juce::ReferenceCountedObjectPtr< ObjectType >::get(), and removeObject().

Referenced by removeObject().

## removeRange()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange | ( | int | startIndex,
|  | int | numberToRemove )

inline

Removes a range of objects from the array.

This will remove a set of objects, starting from the given index, and move any subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

The objects that are removed will have their reference counts decreased, and may be deleted if not referenced from elsewhere.

Parameters

  startIndex | the index of the first object to remove
  numberToRemove | how many objects should be removed

See also
  remove, removeObject

References juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addArray(), getLock(), juce::jlimit(), and minimiseStorageOverheads().

## removeLast()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast | ( | int | howManyToRemove = 1 | ) |

inline

Removes the last n objects from the array.

The objects that are removed will have their reference counts decreased, and may be deleted if not referenced from elsewhere.

Parameters

  howManyToRemove | how many objects to remove from the end of the array

See also
  remove, removeObject, removeRange

References getLock(), and remove().

## swap()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap | ( | int | index1,
|  | int | index2 )

inline noexcept

Swaps a pair of objects in the array.

If either of the indexes passed in is out-of-range, nothing will happen, otherwise the two objects at these positions will be exchanged.

References getLock(), and juce::isPositiveAndBelow().

## move()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::move | ( | int | currentIndex,
|  | int | newIndex )

inline noexcept

Moves one of the objects to a different position.

This will move the object to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the object to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this object to end up. If this is less than zero, it will be moved to the end of the array

References getLock().

## swapWith()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith | ( | OtherArrayType & | otherArray | ) |

inline noexcept

This swaps the contents of this array with those of another array.

If you need to exchange two arrays, this is vastly quicker than using copy-by-value because it just swaps their internal pointers.

References getLock().

Referenced by operator=(), and operator=().

## operator==()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator== | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) | const

inline noexcept

Compares this array to another one.

Returns
  true only if the other array contains the same objects in the same order

References getLock(), and ReferenceCountedArray().

Referenced by operator!=().

## operator!=()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator!= | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) | const

inline noexcept

Compares this array to another one.

See also
  operator==

References operator==(), and ReferenceCountedArray().

## sort()

template<class ObjectClass, class TypeOfCriticalSectionToUse>
template<class ElementComparator>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort | ( | ElementComparator & | comparator,
|  | bool | retainOrderOfEquivalentItems = false )

noexcept

Sorts the elements in the array.

This will use a comparator object to sort the elements into order. The object passed must have a method of the form:

int compareElements (ElementType first, ElementType second);

...and this method must return:

- a value of < 0 if the first comes before the second
- a value of 0 if the two objects are equivalent
- a value of > 0 if the second comes before the first

To improve performance, the compareElements() method can be declared as static or const.

Parameters

  comparator | the comparator to use for comparing elements.
  retainOrderOfEquivalentItems | if this is true, then items which the comparator says are equivalent will be kept in the order in which they currently appear in the array. This is slower to perform, but may be important in some cases. If it's false, a faster algorithm is used, but equivalent elements may be rearranged.

See also
  sortArray

References getLock(), and juce::sortArray().

## minimiseStorageOverheads()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads | ( |  | ) |

inline noexcept

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

References getLock(), and minimiseStorageOverheads().

Referenced by minimiseStorageOverheads(), remove(), removeAndReturn(), and removeRange().

## ensureStorageAllocated()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated | ( | const int | minNumElements | ) |

inline

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

References getLock().

## getLock()

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>

const TypeOfCriticalSectionToUse & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock | ( |  | ) | const

inline noexcept

Returns the CriticalSection that locks this array.

To lock, you can call getLock().enter() and getLock().exit(), or preferably use an object of ScopedLockType as an RAII lock for it.

Referenced by add(), addArray(), addIfNotAlreadyThere(), addOrReplaceSorted(), addSorted(), clear(), clearQuick(), contains(), ensureStorageAllocated(), getFirst(), getLast(), getObjectPointer(), getObjectPointerUnchecked(), indexOf(), indexOfSorted(), minimiseStorageOverheads(), move(), operator==(), remove(), removeAndReturn(), removeLast(), removeObject(), removeRange(), set(), sort(), swap(), and swapWith().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited